#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include "mysql.h"

int main(int argc, char **argv) {
  MYSQL mysql;
  MYSQL_STMT *stmt1, *stmt2;
  MYSQL_BIND bind;

  char txt[100];
  char *ins1, *ins2;
  int id= 0;

  /* ******************************************************************************* */
  /*                               DATABASE CONNECTION:                              */
  /* ******************************************************************************* */

  if(mysql_init(&mysql)==NULL){
    fprintf(stderr, "Failed to initate MySQL connection\n");
    exit (1);
  }

  if(mysql_real_connect(&mysql,"127.0.0.1","root","","test",3306,NULL,0) == NULL)
  {
    fprintf(stderr, "Real connection failed: %s\n", mysql_error(&mysql));
    exit (1);
  }
  printf("\nConnected\n");

  /* ******************************************************************************* */
  /*                          INSERT TEST DATA WITH PS:                              */
  /* ******************************************************************************* */

  stmt1= mysql_stmt_init(&mysql);
  if(!stmt1){
    fprintf(stderr, "mysql_stmt_init(), out of memory\n");
    exit(1);
  }
  ins1= "insert into t(id) values(?)";
  if (mysql_stmt_prepare(stmt1, ins1, strlen(ins1))){
    fprintf(stderr, "mysql_stmt_prepare(), INSERT failed: %s\n", mysql_stmt_error(stmt1));
    exit(1);
  }

  /* Bind data */
  bind.buffer_type= MYSQL_TYPE_LONG;
  bind.buffer= (char *)&id;
  bind.is_null= 0;
  bind.length= 0;


  /* Bind the buffers */
  if (mysql_stmt_bind_param(stmt1, &bind)){
      fprintf(stderr, "mysql_stmt_bind_param() failed: %s\n", mysql_stmt_error(stmt1));
      exit(1);
  }

  /* Specify the data values */
  id = 42;

  printf("prepared statement 1 successfully\n");

  /* prepare the second statement */
  stmt2= mysql_stmt_init(&mysql);
  if(!stmt2){
    fprintf(stderr, "Prepare 2nd statement: mysql_stmt_init(), out of memory\n");
    exit(1);
  }

  puts("shut down server, then press [ENTER] to continue\n");
  gets(txt);

  ins2= "insert into t(num) values(23)";
  if (mysql_stmt_prepare(stmt2, ins2, strlen(ins2))){
    fprintf(stderr, "Prepare 2nd statement: mysql_stmt_prepare(), INSERT failed: %s\n", mysql_stmt_error(stmt2));
	/* exit(1); commented out on purpose */
  } else {
	printf("prepared statement 2 successfully\n");
  }

  /* Execute the 1st INSERT statement */
  if (mysql_stmt_execute(stmt1)){
    fprintf(stderr, "Execute 1st statement, mysql_stmt_execute() failed: %s\n", mysql_stmt_error(stmt1));
    exit(1);
  }

  printf("Data inserted using PS1\n"); 

  /* Execute the 2nd INSERT statement */
  if (mysql_stmt_execute(stmt2)){
    fprintf(stderr, "Execute 2nd statement, mysql_stmt_execute() failed: %s\n", mysql_stmt_error(stmt2));
    exit(1);
  }
  printf("Data inserted with using PS2\n");

  return 0;
}
